<?php

class FrmProStatisticsController{
    function FrmProStatisticsController(){
        add_action('admin_menu', array( &$this, 'menu' ), 24);
        add_action('admin_head-'.FRM_PLUGIN_NAME.'_page_'.FRM_PLUGIN_NAME.'-reports', array(&$this, 'head'));
        add_filter('frm_nav_array', array( &$this, 'frm_nav'), 3);
        add_shortcode('frm-graph', array(&$this, 'graph_shortcode'));
        add_shortcode('frm-stats', array(&$this, 'stats_shortcode'));
    }
    
    function menu(){
        add_submenu_page(FRM_PLUGIN_NAME, FRM_PLUGIN_TITLE .' | '. __('Reports', 'formidable'), '<code>Pro</code> '.__('Reports', 'formidable'), 'frm_view_reports', FRM_PLUGIN_NAME.'-reports', array(&$this, 'show'));
    }
    
    function head(){
        $js_file  = array(FRMPRO_URL.'/js/swfobject.js', FRMPRO_URL.'/js/json2.js');
        require(FRM_VIEWS_PATH . '/shared/head.php');
        require_once(FRMPRO_PATH . '/js/ofc-library/open-flash-chart-object.php');
        require_once(FRMPRO_PATH . '/js/ofc-library/open-flash-chart.php');
    }
    
    function frm_nav($nav){
        if(current_user_can('frm_view_reports'))
            $nav[FRM_PLUGIN_NAME .'-reports'] = __('Reports', 'formidable');
        return $nav;
    }
    
    function show(){
        global $frmdb, $frm_form, $frm_field, $frm_entry_meta, $frm_entry, $wpdb;
        if  (!isset($_GET['form'])){
            require_once(FRMPRO_VIEWS_PATH.'/frmpro-statistics/show.php');
            return;
        }
        
        $form = $frm_form->getOne($_GET['form']);
        //$form_options = maybe_unserialize($form->options);
        $fields = $frm_field->getAll("fi.type not in ('divider','captcha','break','rte','textarea','file','data','grid','html') and fi.form_id=".$form->id, ' ORDER BY field_order ASC');
        
        $js = '';
        $data = array();
        $odd = true;
        $colors = array('#EF8C08', '#21759B', '#1C9E05');
        foreach ($fields as $field){  
            $data[$field->id] = $this->get_graph($field, array('colors' => $colors, 'bg_color' => '#FFFFFF', 'odd' => $odd));
 
            $js .= 'swfobject.embedSWF("'.FRMPRO_URL.'/js/open-flash-chart.swf", "chart_'.$field->id.'",
              "650", "400", "9.0.0", "expressInstall.swf", {"get-data":"get_data_'.$field->id.'"} );';
              
            $odd = $odd ? false : true;
        }
        
        //Chart for Entries Submitted
        $values = array();
        $labels = array();
        $start_timestamp = mktime(0, 0, 0, date("m")-1, date("d"), date("Y"));
        $end_timestamp = time();
        $query = "SELECT DATE(en.created_at) as endate,COUNT(*) as encount FROM $frmdb->entries en WHERE en.created_at BETWEEN '".date("Y-n-j",$start_timestamp)." 00:00:00' AND '".date("Y-n-j",$end_timestamp)." 23:59:59' AND en.form_id=$form->id GROUP BY DATE(en.created_at)";

        $entries_array = $wpdb->get_results($query);

        $temp_array = array();
        $counts_array = array();
        $dates_array = array();

        // Refactor Array for use later on
        foreach($entries_array as $e)
          $temp_array[$e->endate] = $e->encount;

        // Get the dates array
        for($e = $start_timestamp; $e <= $end_timestamp; $e += 60*60*24)
          $dates_array[] = date("Y-m-d",$e);

        // Make sure counts array is in order and includes zero click days
        foreach($dates_array as $date_str){
          if(isset($temp_array[$date_str]))
            $counts_array[$date_str] = $temp_array[$date_str];
          else
            $counts_array[$date_str] = 0;
        }
        
        $date_format = get_option('date_format');
        foreach ($counts_array as $date => $count){
            $labels[] = date($date_format, strtotime($date));
            $values[] = (int)$count;
        }

        $title = new title( 'Daily Entries' );
        
        $line_1_default_dot = new dot();
        $line_1_default_dot->colour($colors[0]);
        $line_1_default_dot->tooltip('#x_label#<br>#val# Entries');
        
        $line_1 = new line();
        $line_1->set_default_dot_style($line_1_default_dot);
        $line_1->set_values( $values );
        $line_1->set_colour( $colors[1] );
        
        $chart = new open_flash_chart();
        $chart->set_title( $title );
        $chart->set_bg_colour( '#FFFFFF' );
        
        $x = new x_axis();
        $x_labels = new x_axis_labels();
        $x_labels->rotate(340);
        $x_labels->set_labels( $labels );
        $x_labels->visible_steps(2);
        $x->set_labels($x_labels);
        
        $chart->set_x_axis( $x );
        
        $y = new y_axis();
        if (!empty($values)){
            $max = max($values)+1;
            $step = ceil($max/10);
            $y->set_range(0, $max, $step);
        }
        $chart->add_element( $line_1 );
        $chart->set_y_axis( $y );
        
        $data['time'] = $chart->toPrettyString();
        $js .= 'swfobject.embedSWF("'.FRMPRO_URL.'/js/open-flash-chart.swf","chart_time","900","300","9.0.0","expressInstall.swf", {"get-data":"get_data_time"} );';
        
        require(FRMPRO_VIEWS_PATH.'/frmpro-statistics/head.php');
        require(FRMPRO_VIEWS_PATH.'/frmpro-statistics/show.php');
    }
    
    function get_graph($field, $args){
        $defaults = array(
            'colors' => array('#EF8C08', '#21759B', '#1C9E05'), 'bg_color' => '#FFFFFF', 
            'odd' => false, 'truncate' => 40, 'truncate_label' => 7, 'response_count' => 10, 
            'user_id' => false, 'type' => 'default'
        );
        extract(wp_parse_args($args, $defaults));
        
        global $frm_entry_meta, $frmdb, $wpdb;           
        $values = $labels = array();
        $title = new title( preg_replace("/&#?[a-z0-9]{2,8};/i", "", FrmAppHelper::truncate($field->name, $truncate)) );
        
        if($user_id){
            $inputs = $wpdb->get_col("SELECT meta_value FROM $frmdb->entry_metas em LEFT JOIN $frmdb->entries e ON (e.id=em.item_id) WHERE em.field_id='{$field->id}' AND user_id='$user_id'");
        }else
            $inputs = $frm_entry_meta->get_entry_metas_for_field($field->id);
            
        $inputs = stripslashes_deep($inputs);
        $field_options = maybe_unserialize($field->options);
        $field->field_options = maybe_unserialize($field->field_options);
        
        $form_posts = $frmdb->get_records($frmdb->entries, array('form_id' => $field->form_id, 'post_id >' => 1), '', '', 'id,post_id');
        if(!empty($form_posts)){
            if(isset($field->field_options['post_field']) and $field->field_options['post_field'] != ''){
                if($field->field_options['post_field'] == 'post_category'){
                    $field_options = FrmProFieldsHelper::get_category_options($field);
                }else if($field->field_options['post_field'] == 'post_custom' and $field->field_options['custom_field'] != ''){
                    //check custom fields
                    foreach($form_posts as $form_post){
                        $meta_value = get_post_meta($form_post->post_id, $field->field_options['custom_field'], true);
                        if($meta_value)
                            $inputs[] = $meta_value;
                    }
                }else{ //if field is post field
                    if($field->field_options['post_field'] == 'post_status')
                        $field_options = FrmProFieldsHelper::get_status_options($field);
                    
                    foreach($form_posts as $form_post){
                        $post_value = $wpdb->get_var("SELECT ". $field->field_options['post_field'] ." FROM $wpdb->posts WHERE ID=".$form_post->post_id);
                        if($post_value)
                            $inputs[] = $post_value;
                    }
                }
            }
        }
            
        $chart = new open_flash_chart();
        $chart->set_title( $title );
        $bar = new bar_glass();
        $x = new x_axis();
        $y = new y_axis();
        $x_labels = new x_axis_labels();
        $pie = false;
        
        if ($field->type == '10radio' or $field->type == 'scale'){
            $minnum = (isset($field->field_options['minnum'])) ? $field->field_options['minnum'] : 1;
            $maxnum = (isset($field->field_options['maxnum'])) ? $field->field_options['maxnum'] : 10;
            for( $i=0; $i<=$maxnum; $i++ )
                $values[$i] = 0;
            
            foreach ($inputs as $in){
                if (isset($values[$in-1])) 
                    $values[$in-1]++;
            }
            
            $x->set_range($minnum, $maxnum, 1);
        }else if ($field->type == 'select' or $field->type == 'checkbox' or $field->type == 'radio'){ 
            foreach ($field_options as $opt_key => $opt){
                $field_val = apply_filters('frm_field_value_saved', $opt, $opt_key, $field->field_options);
                
                $count = 0;
                foreach ($inputs as $in){
                    $in = maybe_unserialize($in);
                    
                    if (FrmAppHelper::check_selected($in, $field_val))
                        $count++;
                }
                if ((int)$count > 0){
                    $labels[] = preg_replace("/&#?[a-z0-9]{2,8};/i", "", FrmAppHelper::truncate($opt, $truncate_label, 2));
                    $values[] = $count;
                }
            }
            
            if ($field->type != 'checkbox') //and count($field_options) == 2
                $pie = true;
            
            /* FOR HORIZONTAL BARS
            $bar = new hbar($colors[$color]);
            $y->set_labels( $labels );
            $y->set_offset( true ); 
            $x->set_offset( false ); */
            
            $x_labels->rotate(340);
            //$x_labels->set_colour( '#A2ACBA' );
            //$x->set_colour( '#A2ACBA' );
        }else if ($field->type == 'user_id'){
            $form = $frmdb->get_one_record($frmdb->forms, array('id' => $field->form_id));
            $form_options = maybe_unserialize($form->options);
            $id_count = array_count_values($inputs);
            if ($form->editable and (isset($form_options['single_entry']) and isset($form_options['single_entry_type']) and $form_options['single_entry_type'] == 'user')){
                //if only one response per user, do a pie chart of users who have submitted the form
                $users_of_blog = get_users_of_blog();
                $total_users = count( $users_of_blog );
                unset($users_of_blog);
                $id_count = count($id_count);
                $not_completed = (int)$total_users - (int)$id_count;
                $labels = array(__('Completed', 'formidable'), __('Not Completed', 'formidable'));
                $values = array($id_count, $not_completed);
                $pie = true;
            }else{
                //arsort($id_count);
                foreach ($id_count as $val => $count){
                    $user_info = get_userdata($val);
                    $labels[] = ($user_info) ? $user_info->display_name : __('Deleted User', 'formidable');
                    $values[] = $count;
                }
                if (count($labels) < 10)
                    $pie = true;
            }
            
            
        }else{
            $id_count = array_count_values(array_map('strtolower', $inputs));
            arsort($id_count);
            $i = 0;
            foreach ($id_count as $val => $count){
                if ($i < $response_count){
                    if ($field->type == 'user_id'){
                        $user_info = get_userdata($val);
                        $labels[] = $user_info->display_name;
                    }else
                        $labels[] = ucwords($val);
                    $values[] = $count;
                }
                $i++;
            }
            
            $x_labels->rotate(340);
        }
        
        $pie = ($type == 'default') ? $pie : (($type == 'pie') ? true : false);
        if ($pie){
            $bar = new pie();
            $bar->set_alpha(0.6);
            $bar->set_start_angle( 35 );
            $bar->add_animation( new pie_fade() );
            $bar->set_tooltip( '#val# of #total#<br>#percent# of 100%' );
            $bar->set_colours( $colors );
            $pie_values = array();
            //$total_count = count($inputs);
            foreach ($values as $val_key => $val)
                $pie_values[] = new pie_value($val, "$labels[$val_key] ($val)");
            
            $bar->set_values( $pie_values );
        }else{
            $color = $odd ? $colors[0] : $colors[1];
            $bar->set_colour( $color);    
            $bar->set_values( $values );
            $x_labels->set_labels( $labels );
            $x->set_labels( $x_labels );
            if (!empty($values)){
                $max = max($values)+1;
                if ($max < 3) $max = 3;
                $step = ceil($max/10);
                $y->set_range(0, $max, $step);
            }
        }

        $chart->add_element( $bar );
        $chart->set_bg_colour( $bg_color );
        
        $chart->set_y_axis( $y );
        $chart->set_x_axis( $x );      
        
        return $chart->toPrettyString();
    }
    
    function graph_shortcode($atts){
        extract(shortcode_atts(array('id' => false, 'include_js' => true, 'colors' => '#EF8C08,#21759B,#1C9E05', 'bg_color' => '#FFFFFF', 'height' => 400, 'width' => 400, 'truncate' => 40, 'truncate_label' => 7, 'response_count' => 10, 'user_id' => false, 'type' => 'default'), $atts));
        if (!$id) return;
        global $frm_field;
        
        if($user_id == 'current'){
            global $user_ID;
            $user_id = $user_ID;
        }
        
        $html = $js = $js_content = $js_content2 = '';
        $fields = $frm_field->getAll("fi.id in ($id)");
        $colors = explode(',', $colors);
        
        require_once(FRMPRO_PATH . '/js/ofc-library/open-flash-chart-object.php');
        require_once(FRMPRO_PATH . '/js/ofc-library/open-flash-chart.php');
        
        $js_content .= '<script type="text/javascript">';
        if($include_js){
            $js_content .= 'if(typeof(swfobject) == "undefined")
                jQuery("head").append(\'<script type="text/javascript" src="'.FRMPRO_URL.'/js/swfobject.js"><\/script>\');
                jQuery("head").append(\'<script type="text/javascript" src="'.FRMPRO_URL.'/js/json2.js"><\/script>\');'."\n";
        }
            
        foreach ($fields as $field){
            $html .= '<div id="chart_'. $field->id .'"></div>';
            $js .= 'swfobject.embedSWF("'.FRMPRO_URL.'/js/open-flash-chart.swf", "chart_'.$field->id.'","'.$width.'","'.$height.'","9.0.0", "expressInstall.swf",{"get-data":"get_data_'.$field->id.'"} );';
            $js_content2 .= 'function get_data_'. $field->id .'(){return JSON.stringify(data_'. $field->id .');}';
            $js_content2 .= 'var data_'. $field->id .'='. $this->get_graph($field, compact('colors', 'bg_color', 'truncate', 'truncate_label', 'response_count', 'user_id', 'type')) .';';
        }
            
        $js_content .= $js . $js_content2;
        $js_content .= '</script>';
        
        return $js_content . $html;
    }
    
    function stats_shortcode($atts){
        $defaults = array(
            'id' => false, 'type' => 'total', 'user_id' => false, 
            'value' => false, 'round' => 100, 'limit' => ''
        );
        
        extract(shortcode_atts($defaults, $atts));
        if (!$id) return;
        if($user_id == 'current'){
            global $user_ID;
            $user_id = $user_ID;
        }
        
        foreach($defaults as $unset => $val)
            unset($atts[$unset]);
            
        return FrmProFieldsHelper::get_field_stats($id, $type, $user_id, $value, $round, $limit, $atts);
    }
}

?>